## rlottie 0~git20190721.24346d0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.3 )

#declare project
project( rlottie VERSION 0.0.1 LANGUAGES C CXX ASM)

add_definitions(-DLOT_BUILD)

#declare target
add_library( rlottie SHARED  "" )

#declare version of the target
set(player_version_major 0)
set(player_version_minor 0)
set(player_version_patch 1)
set(player_version ${player_version_major}.${player_version_minor}.${player_version_patch} )
set_target_properties(rlottie PROPERTIES
                        VERSION    ${player_version}
                        SOVERSION  ${player_version_major}
                      )

#declare alias so that library can be used inside the build tree, e.g. when testing
add_library(rlottie::rlottie ALIAS rlottie)

option(LOTTIE_MODULE "Enable LOTTIE MODULE SUPPORT" ON)
option(LOTTIE_THREAD "Enable LOTTIE THREAD SUPPORT" ON)
option(LOTTIE_CACHE "Enable LOTTIE CACHE SUPPORT" ON)
option(LOTTIE_TEST "Build LOTTIE AUTOTESTS" OFF)

CONFIGURE_FILE(${CMAKE_CURRENT_LIST_DIR}/cmake/config.h.in config.h)

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_BINARY_DIR}"
    )

#declare target compilation options
target_compile_options(rlottie
                    PUBLIC
                    PRIVATE
                        -std=c++14
                        -Os
                        -fno-exceptions
                        -fno-unwind-tables
                        -fno-asynchronous-unwind-tables
                        -fno-rtti
                        -Wall
                        -Werror
                        -Wextra
                        -Wnon-virtual-dtor
                        -Woverloaded-virtual
                        -Wno-unused-parameter
                        -fvisibility=hidden
                    )

#declare dependancy
set( CMAKE_THREAD_PREFER_PTHREAD TRUE )
find_package( Threads )

target_link_libraries(rlottie
                    PUBLIC
                        "${CMAKE_THREAD_LIBS_INIT}"
                     )

# for dlopen, dlsym and dlclose dependancy
target_link_libraries(rlottie
                    PRIVATE
                    ${CMAKE_DL_LIBS})

if(APPLE)
    target_link_libraries(rlottie
                        PUBLIC
                             "-Wl, -undefined error"
                          )
else()
    target_link_libraries(rlottie
                        PUBLIC
                             "-Wl,--no-undefined"
                          )
endif()


if (NOT LIB_INSTALL_DIR)
    set (LIB_INSTALL_DIR "/usr/lib")
endif (NOT LIB_INSTALL_DIR)

#declare source and include files
add_subdirectory(inc)
add_subdirectory(src)
add_subdirectory(example)

if (LOTTIE_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

SET(PREFIX ${CMAKE_INSTALL_PREFIX})
SET(EXEC_DIR ${PREFIX})
SET(LIBDIR ${LIB_INSTALL_DIR})
SET(INCDIR ${PREFIX}/include)

CONFIGURE_FILE(${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)


#install header
install(FILES
        inc/rlottie.h
        inc/rlottie_capi.h
        inc/rlottiecommon.h
        DESTINATION include)

#install lib
install( TARGETS rlottie EXPORT rlottie-targets
         LIBRARY     DESTINATION    ${LIB_INSTALL_DIR}
         ARCHIVE     DESTINATION    ${LIB_INSTALL_DIR}
         INCLUDES    DESTINATION    include
       )

#install config file.

install( EXPORT rlottie-targets
         FILE          rlottieTargets.cmake
         NAMESPACE     rlottie::
         DESTINATION   ${LIB_INSTALL_DIR}/cmake/rlottie
       )


#Create a ConfigVersion.cmake file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/rlottieConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfig.cmake
    INSTALL_DESTINATION ${LIB_INSTALL_DIR}/cmake/rlottie
)

#Install the config, configversion and custom find modules
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfigVersion.cmake
    DESTINATION ${LIB_INSTALL_DIR}/cmake/rlottie
)


export(EXPORT rlottie-targets FILE ${CMAKE_CURRENT_BINARY_DIR}/rlottieTargets.cmake NAMESPACE rlottie::)

#Register package in user's package registry
export(PACKAGE rlottie)

=== src/vector/stb/CMakeLists.txt ===
if(LOTTIE_MODULE)
    add_library(rlottie-image-loader SHARED
                stb_image.cpp
               )
    install(TARGETS rlottie-image-loader
            LIBRARY DESTINATION ${LIB_INSTALL_DIR}
            ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
           )
else()
    target_sources(rlottie
        PRIVATE
            "${CMAKE_CURRENT_LIST_DIR}/stb_image.cpp"
        )
endif()

## rlottie 0~git20190721.24346d0%2Bdfsg

=== debian/changelog ===
rlottie (0~git20190721.24346d0+dfsg-2~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 01 Sep 2019 13:30:11 -0700

rlottie (0~git20190721.24346d0+dfsg-2) unstable; urgency=medium

  * Copy full text of The FreeType Project License to debian/copyright file.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 11 Aug 2019 14:19:58 +0300

rlottie (0~git20190721.24346d0+dfsg-1) unstable; urgency=low

  * Initial upload. (Closes: #931832)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 23 Jul 2019 08:21:50 +0300

=== debian/control ===
Source: rlottie
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 12)
Build-Depends-Arch:
 cmake (>= 3.3),
 libgtest-dev (>= 1.8.0-9) <!nocheck>,
 libstb-dev,
 rapidjson-dev (>= 1.1.0),
Standards-Version: 4.4.0
Rules-Requires-Root: no
Homepage: https://github.com/Samsung/rlottie
Vcs-Git: https://salsa.debian.org/debian/rlottie.git
Vcs-Browser: https://salsa.debian.org/debian/rlottie

Package: librlottie0-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library for rendering vector based animations and art
 Lottie loads and renders animations and vectors exported in the bodymovin JSON
 format. Bodymovin JSON can be created and exported from After Effects with
 bodymovin, Sketch with Lottie Sketch Export, and from Haiku.
 .
 For the first time, designers can create and ship beautiful animations without
 an engineer painstakingly recreating it by hand. Since the animation is backed
 by JSON they are extremely small in size but can be large in complexity.

Package: librlottie-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librlottie0-1 (=${binary:Version}), ${misc:Depends}
Description: library for rendering vector based animations and art (development headers)
 Lottie loads and renders animations and vectors exported in the bodymovin JSON
 format. Bodymovin JSON can be created and exported from After Effects with
 bodymovin, Sketch with Lottie Sketch Export, and from Haiku.
 .
 For the first time, designers can create and ship beautiful animations without
 an engineer painstakingly recreating it by hand. Since the animation is backed
 by JSON they are extremely small in size but can be large in complexity.
 .
 This package provides public C/C++ headers.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
EXTRA_CMAKE_VARIABLES += \
	LOTTIE_CACHE=OFF \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
	LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

ifeq ($(filter nocheck, $(DEB_BUILD_OPTIONS)),)
 EXTRA_CMAKE_VARIABLES += LOTTIE_TEST=ON
endif

export DEB_LDFLAGS_MAINT_APPEND = \
	-Wl,--version-script=$(CURDIR)/debian/rlottie.map
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

# Do not collect exported symbols from the private plugin.
override_dh_makeshlibs:
	dh_makeshlibs -X image-loader.so

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## rlottie 0~git20190721.24346d0+dfsg

=== debian/changelog ===
rlottie (0~git20190721.24346d0+dfsg-2~bpo10+2) buster-backports; urgency=medium

  * Rebuild against libstdc++6 8 (previous build seems to be broken)

 -- Andreas Tille <tille@debian.org>  Thu, 28 Nov 2019 20:00:18 +0100

rlottie (0~git20190721.24346d0+dfsg-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * d/control: Drop "Rules-Requires-Root: no"

 -- Andreas Tille <tille@debian.org>  Fri, 11 Oct 2019 08:22:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rlottie
 Section: libs
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
+Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
 Build-Depends: debhelper-compat (= 12)
 Build-Depends-Arch:
  cmake (>= 3.3),
@@ -10,7 +9,6 @@
  libstb-dev,
  rapidjson-dev (>= 1.1.0),
 Standards-Version: 4.4.0
-Rules-Requires-Root: no
 Homepage: https://github.com/Samsung/rlottie
 Vcs-Git: https://salsa.debian.org/debian/rlottie.git
 Vcs-Browser: https://salsa.debian.org/debian/rlottie

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,3 @@
 # Do not collect exported symbols from the private plugin.
 override_dh_makeshlibs:
 	dh_makeshlibs -X image-loader.so
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## rlottie 0~git20200305.a717479%2Bdfsg

=== debian/changelog ===
rlottie (0~git20200305.a717479+dfsg-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 08 May 2020 13:08:54 -0700

rlottie (0~git20200305.a717479+dfsg-1) unstable; urgency=medium

  * Merge the latest upstream commit.
  * Fix some crashes on corrupted input.
  * Activate in-library cache support.
  * Bump Standards Version to 4.5.0, no related changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 05 Mar 2020 22:16:05 +0300

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: rlottie
 Section: libs
 Priority: optional
-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
 Build-Depends: debhelper-compat (= 12)
 Build-Depends-Arch:
  cmake (>= 3.3),
  libgtest-dev (>= 1.8.0-9) <!nocheck>,
  libstb-dev,
  rapidjson-dev (>= 1.1.0),
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://github.com/Samsung/rlottie
 Vcs-Git: https://salsa.debian.org/debian/rlottie.git
 Vcs-Browser: https://salsa.debian.org/debian/rlottie

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
EXTRA_CMAKE_VARIABLES += \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
	LOTTIE_MODULE_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/rlottie/image-loader.so \
	LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

ifeq ($(filter nocheck, $(DEB_BUILD_OPTIONS)),)
 EXTRA_CMAKE_VARIABLES += LOTTIE_TEST=ON
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

# Do not collect exported symbols from the private plugin.
override_dh_makeshlibs:
	dh_makeshlibs -X image-loader.so

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## rlottie 0~git20200305.a717479+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,10 +3,18 @@
 #declare project
 project( rlottie VERSION 0.0.1 LANGUAGES C CXX ASM)
 
-add_definitions(-DLOT_BUILD)
+if (NOT CMAKE_BUILD_TYPE)
+    set(CMAKE_BUILD_TYPE MinSizeRel)
+endif()
+
+if (NOT DEFINED BUILD_SHARED_LIBS)
+    # Keep the previous behavior of the build system, consistent with Meson.
+    set(BUILD_SHARED_LIBS ON)
+endif()
 
 #declare target
-add_library( rlottie SHARED  "" )
+add_library( rlottie )
+set_target_properties( rlottie PROPERTIES DEFINE_SYMBOL LOT_BUILD )
 
 #declare version of the target
 set(player_version_major 0)
@@ -25,8 +33,13 @@
 option(LOTTIE_THREAD "Enable LOTTIE THREAD SUPPORT" ON)
 option(LOTTIE_CACHE "Enable LOTTIE CACHE SUPPORT" ON)
 option(LOTTIE_TEST "Build LOTTIE AUTOTESTS" OFF)
+option(LOTTIE_CCACHE "Enable LOTTIE ccache SUPPORT" OFF)
+option(LOTTIE_ASAN "Compile with asan" OFF)
 
-CONFIGURE_FILE(${CMAKE_CURRENT_LIST_DIR}/cmake/config.h.in config.h)
+set(LOTTIE_MODULE_PATH "${CMAKE_SHARED_LIBRARY_PREFIX}rlottie-image-loader${CMAKE_SHARED_LIBRARY_SUFFIX}"
+    CACHE STRING "Absolute or relative path to dynamic loader plugin.")
+
+configure_file(${CMAKE_CURRENT_LIST_DIR}/cmake/config.h.in config.h)
 
 target_include_directories(rlottie
     PRIVATE
@@ -38,7 +51,6 @@
                     PUBLIC
                     PRIVATE
                         -std=c++14
-                        -Os
                         -fno-exceptions
                         -fno-unwind-tables
                         -fno-asynchronous-unwind-tables
@@ -61,23 +73,47 @@
                         "${CMAKE_THREAD_LIBS_INIT}"
                      )
 
-# for dlopen, dlsym and dlclose dependancy
-target_link_libraries(rlottie
-                    PRIVATE
-                    ${CMAKE_DL_LIBS})
-
-if(APPLE)
+if (NOT APPLE AND NOT WIN32)
     target_link_libraries(rlottie
-                        PUBLIC
-                             "-Wl, -undefined error"
-                          )
-else()
-    target_link_libraries(rlottie
-                        PUBLIC
-                             "-Wl,--no-undefined"
+                        PRIVATE
+                            "-Wl,--version-script=${CMAKE_SOURCE_DIR}/rlottie.expmap"
                           )
 endif()
 
+if (LOTTIE_MODULE)
+    # for dlopen, dlsym and dlclose dependancy
+    target_link_libraries(rlottie PRIVATE ${CMAKE_DL_LIBS})
+endif()
+
+if (NOT LOTTIE_ASAN)
+    if(APPLE)
+        target_link_libraries(rlottie
+                            PUBLIC
+                                 "-Wl, -undefined error"
+                              )
+    else()
+        target_link_libraries(rlottie
+                            PUBLIC
+                                 "-Wl,--no-undefined"
+                              )
+    endif()
+endif()
+
+if (LOTTIE_CCACHE)
+    find_program(CCACHE_FOUND ccache)
+    if (CCACHE_FOUND)
+        message(STATUS "Found ccache")
+        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
+        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
+    else()
+        message(STATUS "Could NOT find ccache (this is NOT an error)")
+    endif()
+endif()
+
+if (LOTTIE_ASAN)
+    target_compile_options(rlottie PUBLIC -fsanitize=address)
+    target_link_options(rlottie PUBLIC  -fsanitize=address)
+endif()
 
 if (NOT LIB_INSTALL_DIR)
     set (LIB_INSTALL_DIR "/usr/lib")

=== test/CMakeLists.txt ===
project(rlottie_tests CXX)
find_package(GTest REQUIRED)

add_definitions(-DDEMO_DIR="${CMAKE_SOURCE_DIR}/example/resource/")
link_libraries(GTest::GTest GTest::Main)

add_executable(vectorTestSuite testsuite.cpp test_vrect.cpp test_vpath.cpp
    ${CMAKE_SOURCE_DIR}/src/vector/vbezier.cpp
    ${CMAKE_SOURCE_DIR}/src/vector/vdebug.cpp
    ${CMAKE_SOURCE_DIR}/src/vector/vmatrix.cpp
    ${CMAKE_SOURCE_DIR}/src/vector/vpath.cpp)
target_include_directories(vectorTestSuite PRIVATE ${CMAKE_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src/vector ${CMAKE_SOURCE_DIR}/src/vector/pixman)
gtest_add_tests(vectorTestSuite "" AUTO)

add_executable(animationTestSuite testsuite.cpp
    test_lottieanimation.cpp test_lottieanimation_capi.cpp)
target_include_directories(animationTestSuite PRIVATE ${CMAKE_SOURCE_DIR}/inc)
target_link_libraries(animationTestSuite PRIVATE rlottie)
gtest_add_tests(animationTestSuite "" AUTO)

=== src/lottie/CMakeLists.txt ===

target_sources(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/lottieitem.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieitem_capi.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieloader.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottiemodel.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieproxymodel.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieparser.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieanimation.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottiekeypath.cpp"
    )

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}"
    )

=== src/vector/stb/CMakeLists.txt ===
if(LOTTIE_MODULE)
    add_library(rlottie-image-loader SHARED
                stb_image.cpp
               )
    target_compile_options(rlottie-image-loader PRIVATE
                           -fvisibility=hidden
                          )

    get_filename_component(LOTTIE_MODULE_FILENAME ${LOTTIE_MODULE_PATH} NAME)
    get_filename_component(LOTTIE_MODULE_DIR ${LOTTIE_MODULE_PATH} DIRECTORY)
    if (NOT LOTTIE_MODULE_DIR)
        set(LOTTIE_MODULE_DIR ${LIB_INSTALL_DIR})
    endif()

    set_target_properties(rlottie-image-loader PROPERTIES
                          DEFINE_SYMBOL LOT_BUILD
                          PREFIX ""
                          SUFFIX ""
                          OUTPUT_NAME ${LOTTIE_MODULE_FILENAME}
                         )
    install(TARGETS rlottie-image-loader
            LIBRARY DESTINATION ${LOTTIE_MODULE_DIR}
           )
else()
    target_sources(rlottie
        PRIVATE
            "${CMAKE_CURRENT_LIST_DIR}/stb_image.cpp"
        )
endif()

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,3 @@
 # Do not collect exported symbols from the private plugin.
 override_dh_makeshlibs:
 	dh_makeshlibs -X image-loader.so
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts="\
    mode=git, \
    pretty=0~git%cd.%h, \
    repacksuffix=+dfsg, \
    dversionmangle=s/\+dfsg$//" \
https://github.com/Samsung/rlottie heads/master

## rlottie 0.1%2Bdfsg

=== debian/changelog ===
rlottie (0.1+dfsg-4ubuntu1) lunar; urgency=medium

  * debian/patches/fix-static-variable-delete.patch: Fix FTBS on ppc64el
    (LP: #2009551).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 07 Mar 2023 15:32:12 +1300

rlottie (0.1+dfsg-4) unstable; urgency=medium

  * Update No-cyclic-structures.patch (Closes: #1019499).
    - Move check of layer self-nesting to parsing stage from rendering.
  * Rewrite Atomic-render.patch (Closes: #1018725).
    - Use non-blocking std::atomic_flag instead of std::atomic_bool, because
      the flag does not require linking against libatomic on RISC-V 64bit.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 10 Sep 2022 18:49:38 +0300

rlottie (0.1+dfsg-3) unstable; urgency=medium

  * Apply fixes and improve stability (Closes: #995728, #1016406).
    - New patches:
      + Atomic-render.patch
      + Avoid-assertion-failures.patch
      + Check-empty-frames.patch
      + Finite-loop-in-VBezier-tAtLength.patch
      + Ignore-unspecified-type.patch
      + Init-keyframe.patch
      + No-cyclic-structures.patch
      + No-deadlock.patch
      + Positive-points.patch
      + Reject-reversed-frames.patch
      + Stop-VBezier-length-overflow.patch
    - Amended patches:
      + Check-buffer-length.patch
      + Fortify-FreeType-raster.patch
    - Replace Zero-corrupt-point.patch with Empty-animation-data.patch based on
      Subhransu Mohanty's commit (Closes: #994614)
    - Import another his commit as Improve-rendering-performance.patch.
  * Update Debhelper compatibility level to 13.
    - Remove CMAKE_SKIP_INSTALL_ALL_DEPENDENCY variable.
  * Declare compliance with Standards Version of v4.6.1, no required changes.
  * Ignore very-long-line-length-in-source-file Lintian tag in JSON examples.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 08 Aug 2022 13:25:43 +0300

rlottie (0.1+dfsg-2) unstable; urgency=medium

  * Update patches.
    - Sync patches with John Preston's fork.
      + New Freetype-raster.patch for fix CVE-2021-31321. (Closes: #988885)
      + New Fortify-lottie-parser.patch for fix crashes on invalid input.
    - New Extend-mDash-array.patch for fix CVE-2021-31317. (Closes: #988885)
    - New Include-limits-header.patch for fix build with the latest GCC.
      (Closes: #984323)
    - New Zero-corrupt-point.patch for fix crash on inappropriate shape.
      (Closes: #974095)
    - New Avoid-nullptr-in-solidColor.patch fixes null pointer dereferencing.
    - Fix error handling of broken JSON that led to crashes.
  * Skip RAPIDJSON_ASSERT as in Telegram or in upstream rLottie.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 02 Jun 2021 09:23:26 +0300

rlottie (0.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Add upstream metadata.
  * Update debian/watch file for the first release.
  * Apply John Preston's fixes for improve stability.
    - Check-buffer-length.patch
    - Fix-crash-in-malformed-animations.patch
    - Fix-crash-on-invalid-data.patch

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 19 Jul 2020 21:43:03 +0300

## rlottie 0.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required( VERSION 3.3 )
 
 #declare project
-project( rlottie VERSION 0.0.1 LANGUAGES C CXX ASM)
+project( rlottie VERSION 0.1 LANGUAGES C CXX ASM)
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE MinSizeRel)

=== meson_options.txt ===
option('thread',
   type: 'boolean',
   value: true,
   description: 'Enable threading in rlottie')

option('cache',
   type: 'boolean',
   value: true,
   description: 'Enable cache support in rlottie')

option('module',
   type: 'boolean',
   value: true,
   description: 'Enable module support in rlottie')

option('moduledir',
   type: 'string',
   description: 'Dynamic plugins directory')

option('log',
   type: 'boolean',
   value: false,
   description: 'Enable logging in rlottie')

option('dumptree',
   type: 'boolean',
   value: false,
   description: 'Enable logging the rlottie tree in rlottie')

option('test',
   type: 'boolean',
   value: false,
   description: 'Enable building unit tests')

option('example',
   type: 'boolean',
   value: true,
   description: 'Enable building examples')

option('cmake',
  type: 'boolean',
  value: false,
  description: 'Enable Generating  CMake config files')

=== example/CMakeLists.txt ===
add_executable(lottie2gif "lottie2gif.cpp")

target_compile_options(lottie2gif
                       PRIVATE
                       -std=c++14)

target_link_libraries(lottie2gif rlottie)

target_include_directories(lottie2gif
                           PRIVATE
                           "${CMAKE_CURRENT_LIST_DIR}/../inc/")

=== src/CMakeLists.txt ===

add_subdirectory(vector)

add_subdirectory(lottie)

add_subdirectory(binding)

=== src/vector/CMakeLists.txt ===
add_subdirectory(freetype)
add_subdirectory(pixman)
add_subdirectory(stb)


target_sources(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/vrect.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vdasher.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vbrush.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vbitmap.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vpainter.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vcompositionfunctions.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vdrawhelper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vdrawhelper_sse2.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vdrawhelper_neon.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vrle.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vpath.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vpathmesure.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vmatrix.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/velapsedtimer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vdebug.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vinterpolator.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vbezier.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vraster.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vdrawable.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/vimageloader.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/varenaalloc.cpp"
    )

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}"
    )

=== src/binding/c/CMakeLists.txt ===
target_sources(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/lottieanimation_capi.cpp"
    )

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}"
    )

=== src/vector/pixman/CMakeLists.txt ===

IF("${ARCH}" STREQUAL "arm")
SET(CMAKE_ASM_FLAGS "${CFLAGS} -x assembler-with-cpp")
target_sources(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/pixman-arm-neon-asm.S"
    )
ENDIF("${ARCH}" STREQUAL "arm")

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}"
    )

=== debian/changelog ===
rlottie (0.1+dfsg-2ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Stack-based buffer overflow patch was incomplete
    - debian/patches/Check-buffer-length.patch: Amend patch to properly
      check buffer bounds in the src/vector/vrle.cpp blit function
      and its variants.
    - CVE-2021-31315
  * SECURITY UPDATE: Stack-based buffer overflow patch was incomplete
    - debian/patches/Freetype-raster.patch: Amend patch to correctly
      check return conditions in the gray_render_cubic function and also
      check the number of ycells in the gray_find_cell function of
      src/vector/freetype/v_ft_raster.cpp.
    - CVE-2021-31321
  * debian/rules: Use compiler flag for level 2 optimization (-O2)
    instead of level 3 (-O3) on ppc64el architectures. Level 3
    optimization can lead to build errors due to memory alignment
    requirements. 

 -- Nicolas Campuzano Jimenez <nicolas.campuzano@canonical.com>  Thu, 19 Dec 2024 12:33:21 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: rlottie
 Section: libs
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
 Build-Depends: debhelper-compat (= 12)
 Build-Depends-Arch:

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,18 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
+# Silence assert failures in LottieParser that may be raised due to unexpected
+# input data. See Telegram build scripts: https://github.com/desktop-app/cmake_helpers/blob/ac193a597d6b953f9869a240e21e275ce6e388cb/external/rlottie/CMakeLists.txt#L116
+export DEB_CPPFLAGS_MAINT_APPEND = -DRAPIDJSON_ASSERT=\(void\)
+
+#Avoid using compiler level 3 optimization on ppc64el architectures; use level 2 instead. Level 3 can lead to build errors regarding memory alignment requirements after GCC5.
+ifeq ($(DEB_HOST_ARCH),ppc64el)
+  export DEB_CFLAGS_MAINT_STRIP = -O3
+  export DEB_CFLAGS_MAINT_APPEND = -O2
+  export DEB_CPPFLAGS_MAINT_STRIP := -O3
+  DEB_CPPFLAGS_MAINT_APPEND += -O2
+endif
+
 %:
 	dh $@

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg, dversionmangle=s/\+dfsg$//" \
  https://github.com/Samsung/rlottie/releases/latest (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## rlottie python-1.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)
project(rlottie-python)

add_subdirectory(rlottie)

# Install the module
if (WIN32)
    install(TARGETS rlottie
            EXCLUDE_FROM_ALL
            RUNTIME DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
            COMPONENT python_module)
else()
    install(TARGETS rlottie
            EXCLUDE_FROM_ALL
            LIBRARY DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
            COMPONENT python_module)
endif()

=== rlottie/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.3 )

#declare project
project( rlottie VERSION 0.2 LANGUAGES C CXX ASM)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE MinSizeRel)
endif()

if (NOT DEFINED BUILD_SHARED_LIBS)
    # Keep the previous behavior of the build system, consistent with Meson.
    set(BUILD_SHARED_LIBS ON)
endif()

#declare target
add_library( rlottie )
set_target_properties( rlottie PROPERTIES DEFINE_SYMBOL RLOTTIE_BUILD )

#declare version of the target
set(player_version_major 0)
set(player_version_minor 2)
set(player_version ${player_version_major}.${player_version_minor})
set_target_properties(rlottie PROPERTIES
                        VERSION    ${player_version}
                        SOVERSION  ${player_version_major}
                      )

#declare alias so that library can be used inside the build tree, e.g. when testing
add_library(rlottie::rlottie ALIAS rlottie)

option(LOTTIE_MODULE "Enable LOTTIE MODULE SUPPORT" ON)
option(LOTTIE_THREAD "Enable LOTTIE THREAD SUPPORT" ON)
option(LOTTIE_CACHE "Enable LOTTIE CACHE SUPPORT" ON)
option(LOTTIE_TEST "Build LOTTIE AUTOTESTS" OFF)
option(LOTTIE_CCACHE "Enable LOTTIE ccache SUPPORT" OFF)
option(LOTTIE_ASAN "Compile with asan" OFF)

set(LOTTIE_MODULE_PATH "${CMAKE_SHARED_LIBRARY_PREFIX}rlottie-image-loader${CMAKE_SHARED_LIBRARY_SUFFIX}"
    CACHE STRING "Absolute or relative path to dynamic loader plugin.")

configure_file(${CMAKE_CURRENT_LIST_DIR}/cmake/config.h.in config.h)

target_include_directories(rlottie
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
    PRIVATE
        "${CMAKE_CURRENT_BINARY_DIR}"
    )

#declare common target compilation options
if(MSVC)
    target_compile_options(rlottie
                        PUBLIC
                        PRIVATE
                            /std:c++14
                            /EHs-c- # disable exceptions
                            /GR- # disable RTTI
                            /W3
                        )
else()
    target_compile_options(rlottie
                        PUBLIC
                        PRIVATE
                            -std=c++14
                            -fno-exceptions
                            -fno-unwind-tables
                            -fno-asynchronous-unwind-tables
                            -fno-rtti
                            -Wall
                            -fvisibility=hidden
                            -Wnon-virtual-dtor
                            -Woverloaded-virtual
                            -Wno-unused-parameter
                        )
endif()

if (WIN32 AND NOT BUILD_SHARED_LIBS)
    target_compile_definitions(rlottie PUBLIC -DRLOTTIE_BUILD=0)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
endif()

#declare dependancy
set( CMAKE_THREAD_PREFER_PTHREAD TRUE )
find_package( Threads )

target_link_libraries(rlottie
                    PUBLIC
                        "${CMAKE_THREAD_LIBS_INIT}"
                     )

if (NOT APPLE AND NOT WIN32)
    target_link_libraries(rlottie
                        PRIVATE
                            "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/rlottie.expmap"
                          )
endif()

if (LOTTIE_MODULE)
    # for dlopen, dlsym and dlclose dependancy
    target_link_libraries(rlottie PRIVATE ${CMAKE_DL_LIBS})
endif()

if (NOT LOTTIE_ASAN)
    if(APPLE)
        target_link_libraries(rlottie
                            PUBLIC
                                 "-Wl, -undefined error"
                              )
    elseif(NOT MSVC)
        target_link_libraries(rlottie
                            PUBLIC
                                 "-Wl,--no-undefined"
                              )
    endif()
endif()

if (LOTTIE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if (CCACHE_FOUND)
        message(STATUS "Found ccache")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    else()
        message(STATUS "Could NOT find ccache (this is NOT an error)")
    endif()
endif()

if (LOTTIE_ASAN)
    target_compile_options(rlottie PUBLIC -fsanitize=address)
    target_link_options(rlottie PUBLIC  -fsanitize=address)
endif()

if (NOT LIB_INSTALL_DIR)
    set (LIB_INSTALL_DIR "/usr/local/lib")
endif (NOT LIB_INSTALL_DIR)

#declare source and include files
add_subdirectory(inc)
add_subdirectory(src)
add_subdirectory(example)

if (LOTTIE_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

SET(PREFIX ${CMAKE_INSTALL_PREFIX})
SET(EXEC_DIR ${PREFIX})
SET(LIBDIR ${LIB_INSTALL_DIR})
SET(INCDIR ${PREFIX}/include)

CONFIGURE_FILE(${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)


#install header
install(FILES
        inc/rlottie.h
        inc/rlottie_capi.h
        inc/rlottiecommon.h
        DESTINATION include)

#install lib
install( TARGETS rlottie EXPORT rlottie-targets
         LIBRARY     DESTINATION    ${LIB_INSTALL_DIR}
         ARCHIVE     DESTINATION    ${LIB_INSTALL_DIR}
         INCLUDES    DESTINATION    include
       )

#install config file.

install( EXPORT rlottie-targets
         FILE          rlottieTargets.cmake
         NAMESPACE     rlottie::
         DESTINATION   ${LIB_INSTALL_DIR}/cmake/rlottie
       )


#Create a ConfigVersion.cmake file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/rlottieConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfig.cmake
    INSTALL_DESTINATION ${LIB_INSTALL_DIR}/cmake/rlottie
)

#Install the config, configversion and custom find modules
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfigVersion.cmake
    DESTINATION ${LIB_INSTALL_DIR}/cmake/rlottie
)


export(EXPORT rlottie-targets FILE ${CMAKE_CURRENT_BINARY_DIR}/rlottieTargets.cmake NAMESPACE rlottie::)

#Register package in user's package registry
export(PACKAGE rlottie)

=== rlottie/src/lottie/zip/CMakeLists.txt ===
target_sources(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/zip.cpp"
    )

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}"
    )

## rlottie python-1.3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,13 @@
 cmake_minimum_required(VERSION 3.17)
 project(rlottie-python)
+
+if (MSVC)
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
+    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
+elseif (LINUX)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
+endif()
 
 add_subdirectory(rlottie)

=== rlottie/CMakeLists.txt ===
--- 
+++ 
@@ -83,9 +83,14 @@
 set( CMAKE_THREAD_PREFER_PTHREAD TRUE )
 find_package( Threads )
 
+if(WIN32)
+   set( OSSPEC_LIBS Shlwapi.lib )
+endif()
+
 target_link_libraries(rlottie
                     PUBLIC
                         "${CMAKE_THREAD_LIBS_INIT}"
+                        ${OSSPEC_LIBS}
                      )
 
 if (NOT APPLE AND NOT WIN32)

=== rlottie/src/lottie/CMakeLists.txt ===
add_subdirectory(zip)

target_sources(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/lottieitem.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieitem_capi.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieloader.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottiemodel.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieproxymodel.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieparser.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottieanimation.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lottiekeypath.cpp"
    )

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}"
    )
